<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xrl="http://netkernel.org/xrl" xmlns:nk="http://netkernel.org">
  <xsl:output method="xml"/>
  
  	<xsl:param name="filter" nk:class="java.lang.String"/>

	<xsl:template match="/modules">
		<div>
  			<table>
  			<tr>
  			<td>
  			
  				<xrl:include>
				 <xrl:identifier>active:controlPanelInfoBoxOpen</xrl:identifier>
				 <xrl:argument name="content">
				   <div>
						<h3 style="margin-top: 0;">Notes</h3>
						<p>
						To generate javadoc you must have the JDK 'javadoc' tool in your operating system's path.
						You can only generate javadoc on a module that has Java source files. 
						</p>
						<h3>Searchable Javadoc</h3>
						<p>
						After you have generated javadoc you can add it to the search index of the system by rebuilding
						the search index.
						</p>
				   </div>
				 </xrl:argument>
				</xrl:include> 
  			
  			<form action="/tools/javadoc/" method="get"><table class="form-table"><tr>
  				<td><input class="btn btn-default" type="text" name="filter" id="Filter on partial string match of module URI"/></td>
  				<td><input class="btn btn-default" type="submit" value="Filter" /></td>
  				<td><input class="btn btn-default" type="button" value="Generate All" onclick="parent.location='/tools/javadoc/generate-all'"/></td>
				<td><input class="btn btn-default" type="button" value="Rebuild Search Index" onclick="parent.location='/tools/search/fullIndex'"/></td>
			</tr></table></form>

			<table class="table table-condensed">
		    	<tr>
		    		<th/>
			    	<th>
			    		Name
			    	</th>
			    	<th>
			    		Version
			    	</th>
			    	<th>
			    		Generated
			    	</th>
			    	<th/><th/>
		    	</tr>
		    	<xsl:for-each select="module[runlevel='0' and (contains(id,'standard') or contains(id,'api') or contains(id,'layer0'))]">
		    		<xsl:choose>
		    			<xsl:when test="contains(id,'standard')">
		    				<xsl:call-template name="module">
		    					<xsl:with-param name="name">Standard Module Base Classes</xsl:with-param>
		    					<xsl:with-param name="icon">1</xsl:with-param>
		    				</xsl:call-template>
		    			</xsl:when>
		    			<xsl:when test="contains(id,'api')">
		    				<xsl:call-template name="module">
		    					<xsl:with-param name="name">Kernel API</xsl:with-param>
		    					<xsl:with-param name="icon">1</xsl:with-param>
		    				</xsl:call-template>
		    			</xsl:when>
		    			<xsl:when test="contains(id,'layer0') and not(contains(id,'enterprise') )">
		    				<xsl:call-template name="module">
		    					<xsl:with-param name="name">NetKernel Foundation API (NKF)</xsl:with-param>
		    					<xsl:with-param name="icon">1</xsl:with-param>
		    				</xsl:call-template>
		    			</xsl:when>
		    		</xsl:choose>
		    	</xsl:for-each>
		    	<tr>
		    		<td colspan="6"><hr/></td>
		    	</tr>
		    	<xsl:for-each select="module[runlevel&gt;0]">
		    		<xsl:sort select="dotted"/>
		    		<xsl:call-template name="module">
		    			<xsl:with-param name="offset">1</xsl:with-param>
		    		</xsl:call-template>
		    	</xsl:for-each>
		    </table>
		    </td>
		    <td style="vertical-align: top;">
		    
	    	</td>
	    	</tr>
	    	</table>    
  		</div>
  	</xsl:template>
  	
  	<xsl:template name="module">
  		<xsl:param name="name"/>
  		<xsl:param name="offset">0</xsl:param>
  		<xsl:param name="icon">0</xsl:param>
  		<xsl:if test="not( $filter ) or contains(id, $filter) or runlevel=0">
	  		<tr>
				<xsl:choose>
		  			<xsl:when test="(position()+$offset) mod 2 = 0">
		  				<xsl:attribute name="class">evenrow</xsl:attribute>
		  			</xsl:when>
		  			<xsl:otherwise>
		  				<xsl:attribute name="class">oddrow</xsl:attribute>
		  			</xsl:otherwise>
		  		</xsl:choose>
		  		<td>
		  			<xsl:if test="$icon=1">
		  				<img src="/nkse/style/img/favicon.png"/>
		  			</xsl:if>
		  		</td>
		  		<td>
		  			<xsl:choose>
		  				<xsl:when test="$name"><xsl:value-of select="$name"/></xsl:when>
		  				<xsl:otherwise><xsl:value-of select="id"/></xsl:otherwise>
		  			</xsl:choose>
		  		</td>
		  		<td>
		  			<xsl:value-of select="version"/>
		  		</td>
		  		<td>
		  			<xsl:choose>
		  				<xsl:when test="string-length(touch)">
		  					<xsl:value-of select="touch"/>
		  				</xsl:when>
		  				<xsl:otherwise>
		  					---
		  				</xsl:otherwise>
		  			</xsl:choose>
		  		</td>
		  		<td align="center">
		  			<xsl:if test="string-length(touch)">
		  				<a href="./view/{dotted}-{version}/index.html" >view</a>
		  			</xsl:if>
		  		</td>
		  		<td align="center">
		  			<a href="generate/{guid}">generate</a>
		  		</td>
	  		</tr>
	  	</xsl:if>
  	</xsl:template>
    
</xsl:stylesheet> 
