<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:nk="http://netkernel.org" xmlns:xrl="http://netkernel.org/xrl">
    
    <xsl:output method="xml" omit-xml-declaration="yes"/>
    <xsl:param name="modules"/>
    
	<xsl:template match="/spaces">
		<books>
			<book>
				<id>book:mod:reference</id>
				<title>NetKernel Component Reference</title>
				<desc>A listing of all deployed accessors, overlays, transports, transreptors and representations</desc>
				<author/>
				<publisher/>
				<date/>
				<modified/>
				<icon>res:/book/image/book-reference.png</icon>
				<keywords/>
				<lastResort/> <!-- stops docs from being resolved in this book except as a last resort -->
				<toc>
					<item id="doc:compref:title" title="Preface"/>
					<xsl:call-template name="section-flat">
						<xsl:with-param name="category" select="'scheme'"/>
					</xsl:call-template>
					<separator/>
					<xsl:call-template name="section-flat">
						<xsl:with-param name="category" select="'transport'"/>
					</xsl:call-template>
					<separator/>
					<xsl:call-template name="section-flat">
						<xsl:with-param name="category" select="'runtime'"/>
					</xsl:call-template>
					<separator/>
					<xsl:call-template name="accessor">
					</xsl:call-template>
					<!--
					<separator/>
					<xsl:call-template name="section-flat">
						<xsl:with-param name="category" select="'overlay'"/>
					</xsl:call-template>-->
					<separator/>
					<xsl:call-template name="section-flat">
						<xsl:with-param name="category" select="'transreptor'"/>
					</xsl:call-template>
					<separator/>
					<xsl:call-template name="section-flat">
						<xsl:with-param name="category" select="'representation'"/>
					</xsl:call-template>
				</toc>
			</book>
		</books>
    </xsl:template>
    
    <xsl:template name="accessor">
    	<item id="doc:compref:accessor">
    		<xsl:for-each select="space[docs/doc[contains(category,'accessor') or contains(category,'overlay')]]">
   				<xsl:sort select="id"/>
    			<xsl:variable name="spaceId" select="id"/>
    			<xsl:variable name="spaceName" select="$modules/modules/module[spaces/space/id=$spaceId]/name">
    			</xsl:variable>
    			<item id="doc:compref:accessor:{id}" title="{$spaceName}">
    				<xsl:for-each select="docs/doc[contains(category,'accessor') or contains(category,'overlay')]">
    					<item id="{id}"/>
    				</xsl:for-each>
    			</item>
    		</xsl:for-each>
    	</item>
    </xsl:template>	
	
    <xsl:template name="section-flat">
    	<xsl:param name="category"/>
    	<item id="doc:compref:{$category}">
			<xsl:for-each select="space/docs/doc[contains(category,$category)]">
				<item id="{id}"/>
			</xsl:for-each>
    	</item>
    </xsl:template>	

</xsl:stylesheet>
