package org.netkernel.doc.endpoint;

import java.net.URI;
import java.io.StringReader;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.util.XMLUtils;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.urii.impl.NetKernelException;


/**
 * This engine will ignore the wrapped text
 */


public class IgnoreEngine extends StandardAccessorImpl
    {
    public IgnoreEngine()
        {
        this.declareThreadSafe();
        }


    @Override
    public void onSource(INKFRequestContext aContext) throws Exception
        {
        String type = aContext.getThisRequest().getArgumentValue("activeType");
        Object result;

        if (type.endsWith("XHTML"))
            {
            result = "<div/>";
            }
        else if (type.endsWith("DOCBOOK"))
            {
            result = "<div/>";
            }
        else
            {
            throw new NetKernelException("Undefined returned type");
            }
        aContext.createResponseFrom(result);
        }

    }
