package org.netkernel.doc.endpoint;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;


/**
 * This engine will return the enclosed text in markup that will indicate this is an
 * "author's note either to self or others.
 */


public class SearchEngine extends StandardAccessorImpl
  {
  public SearchEngine()
    {
    this.declareThreadSafe();
    }


  @Override
  public void onSource(INKFRequestContext aContext) throws Exception
    {
    String type = aContext.getThisRequest().getArgumentValue("activeType");
    String operandValue = (String) aContext.source("arg:operand", String.class);
    boolean searchAndDisplay =  operandValue.contains("|");
    boolean lucky=type.contains("LUCKY");
    boolean inline=type.contains("INLINE");
    if (type.endsWith("XHTML"))
      {
    	if(inline)
    	{
    		Object result=null;
    		try
    		{
	    		INKFRequest req=aContext.createRequest("active:nkseSearch");
	    		req.addArgumentByValue("operand", operandValue);
	    		Object rep=aContext.issueRequest(req);
	    		
	    		req=aContext.createRequest("active:xslt");
	    		req.addArgumentByValue("operand", rep);
	    		req.addArgument("operator", "res:/org/netkernel/doc/endpoint/style-inline-search.xsl");
	    		req.setRepresentationClass(String.class);
	    		result=aContext.issueRequest(req);
    		}
    		catch(Exception e)
    		{	result="<div style=\"font-size: 120%\">Search Error - index not built or running from Jar</div>";    			
    		}
    		aContext.createResponseFrom(result);
    	}
    	else
    	{
	    	String href="/tools/search/?search=";
	    	String value;
	      // XHTML
	      if (searchAndDisplay)
	        {
	    	  href+=operandValue.substring(0, operandValue.indexOf("|"));
	    	  value=operandValue.substring(operandValue.indexOf("|") + 1);
	        }
	      else
	        {
	    	  href+=operandValue;
	    	  value=operandValue;
	        }
	      	if(lucky)
	      	{	href+="&amp;lucky=true";      		
	      	}
	      	aContext.createResponseFrom("<a class=\"search-link\" href=\"" + href + "\">" +value + "</a><img src=\"/nkse/style/img/external-link.png\"/>");
    	}
      }
    else
      {  //Docbook
      aContext.createResponseFrom("<note><![CDATA[" + operandValue + "]]></note>");
      }
    }

  }
